package com.zhentao;

import java.io.IOException;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.ArrayList;
import java.util.List;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

public class Python {
    public static void main(String[] args) {
        List<String> info = getBaiduHomepageInfo("https://www.jingdong.com");
        for (String item : info) {
            System.out.println(item);
        }
    }
    public static List<String> getBaiduHomepageInfo(String url) {
        List<String> info = new ArrayList<>();
        try {
// 创建 HTTP 客户端
            HttpClient client = HttpClient.newHttpClient ();
// 创建 HTTP 请求并设置请求头
            HttpRequest request = HttpRequest.newBuilder ()
                    .uri (URI.create (url))
                    .header ("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3")
                    .build ();
// 发送请求并获取响应
            HttpResponse<String> response = client.send (request, HttpResponse.BodyHandlers.ofString ());
            if (response.statusCode () == 200) {
// 使用 Jsoup 解析 HTML
                Document doc = Jsoup.parse (response.body ());
// 这里可根据具体需求选择要提取的信息，例如提取所有链接文本
                Elements links = doc.select ("a");
                for (Element link : links) {
                    info.add (link.text ());
                }
            }
        } catch (IOException | InterruptedException e) {
            e.printStackTrace ();
        }
        return info;
    }
}
