package com.zhentao.controller;

import cn.hutool.crypto.digest.DigestUtil;
import com.zhentao.pojo.CeShi;
import com.zhentao.pojo.Object1;
import jakarta.validation.ConstraintViolation;
import jakarta.validation.Validation;
import jakarta.validation.Validator;
import jakarta.validation.ValidatorFactory;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigDecimal;
import java.util.Set;

@RestController
@RequestMapping("api")
public class ApiController {
    public static String generateMD5Signature(String appId, String goodsId, String reqId, String reqTime, String appKey) {
        String input = appId + goodsId + reqId + reqTime + appKey;
//        try {
//            // 获取 MD5 算法的 MessageDigest 实例
//            MessageDigest md = MessageDigest.getInstance("MD5");
//            // 将输入字符串转换为字节数组并更新到 MessageDigest 中
//            byte[] messageDigest = md.digest(input.getBytes());
//            StringBuilder hexString = new StringBuilder();
//            for (byte b : messageDigest) {
//                String hex = Integer.toHexString(0xFF & b);
//                System.err.println(hex);
//                if (hex.length() == 1) {
//                    hexString.append('0');
//                }
//                hexString.append(hex);
//            }
//            // 返回生成的 MD5 签名
//            return hexString.toString();
//        } catch (NoSuchAlgorithmException e) {
//            // 若 MD5 算法不可用，抛出运行时异常
//            throw new RuntimeException(e);
//        }
        return DigestUtil.md5Hex(input);
    }

    // 验证签名的方法
    public static boolean verifySignature(String appId, String goodsId, String reqId, String reqTime, String appKey, String receivedSignature) {
        String generatedSignature = generateMD5Signature(appId, goodsId, reqId, reqTime, appKey);
        return generatedSignature.equals(receivedSignature);
    }
    @RequestMapping("/find1")
    public Object1 find1(@RequestBody Object1 object1,@RequestHeader("reqId") String reqId){

        ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
        Validator validator = factory.getValidator();
        Set<ConstraintViolation<Object1>> violations = validator.validate(object1);

        if (violations.isEmpty()) {
            System.out.println("邮箱地址验证通过");
            String yourAppKey = ApiController.generateMD5Signature(object1.getAppId(), object1.getGoodsId().toString(), reqId, "20250331120000", "yourAppKey");
            System.err.println(yourAppKey);
            return object1;
        } else {
            for (ConstraintViolation<Object1> violation : violations) {
                System.out.println(violation.getMessage());
                return null;
            }
            return null;
        }
    }
    @RequestMapping("/find2")
    public Object1 find2(String appId,
                                Integer goodsId,
                         BigDecimal price,
                         String mobile,@RequestHeader("reqId") String reqId){
        Object1 object1=new Object1();
        object1.setAppId(appId);
        object1.setGoodsId(goodsId);
        object1.setPrice(price);
        object1.setMobile(mobile);
        System.err.println(reqId);
        ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
        Validator validator = factory.getValidator();
        Set<ConstraintViolation<Object1>> violations = validator.validate(object1);
        if (violations.isEmpty()) {
            System.out.println("邮箱地址验证通过");

            return object1;
        } else {
            for (ConstraintViolation<Object1> violation : violations) {
                System.out.println(violation.getMessage());
                return null;
            }
            return null;
        }
    }
}
